

#ifndef USER_H
#define USER_H



#define OUTPUT_PIN 0
#define INPUT_PIN 1


/***
 * PWM period =[(period ) + 1] x 4 x TOSC x TMR2 prescaler
 * 
 * PWM period = (PWM_PR2 + 1)*4*Tosc*TMR2PRES
 *            = (224+1)*4*(1/48MHz)*16
 *            = 0.000298667 Seconds
 *            = 299 uS
 * PWM frequency = 3.3 KHz
 *
 * 
 * Duty cycle = (PWM_DC) x TOSC * RMR2PRES
 *            = 90*(1/48MHz) * 16
 *            = 0.00003 Seconds
 *            = 30 uS
 */
 
#define PWM_PR2          149
#define PWM_DC           200 /* 0 to 600 */
#define VOLT_TO_DC(X)    (10*(X))/17          
#define TMR2_PRE_SCALE  T2_PS_1_16 




// OUTPUT
#define LED_P14       PORTBbits.RB4
#define LED_P13       PORTBbits.RB5
#define LED_P12       PORTBbits.RB6
#define LED_P11       PORTBbits.RB7
#define LED_P10       PORTBbits.RB3
#define LED_P9       PORTBbits.RB2
#define LED_P8       PORTBbits.RB1
#define LED_P7       PORTBbits.RB0
#define LED_P6       PORTDbits.RD7
#define LED_P5      PORTDbits.RD6
#define LED_P4      PORTDbits.RD2
#define LED_P3      PORTDbits.RD3
#define LED_P2      PORTDbits.RD1
#define LED_P1      PORTDbits.RD0


#define TRIS_OUTPUT TRISBbits.TRISB7 = OUTPUT_PIN; \
                    TRISBbits.TRISB6 = OUTPUT_PIN; \
                    TRISBbits.TRISB5 = OUTPUT_PIN; \
                    TRISBbits.TRISB4 = OUTPUT_PIN; \
                    TRISBbits.TRISB3 = OUTPUT_PIN; \
                    TRISBbits.TRISB2 = OUTPUT_PIN; \
                    TRISBbits.TRISB1 = OUTPUT_PIN; \
                    TRISBbits.TRISB0 = OUTPUT_PIN; \
                    TRISDbits.TRISD7 = OUTPUT_PIN; \
                    TRISDbits.TRISD6 = OUTPUT_PIN; \
                    TRISDbits.TRISD3 = OUTPUT_PIN; \
                    TRISDbits.TRISD1 = OUTPUT_PIN; \
                    TRISDbits.TRISD0 = OUTPUT_PIN; 
                    
                    
#define LED_ON LED_P1=1;\
                LED_P2=1;\
                LED_P3=1;\
                LED_P4=1;\
                LED_P5=1;\
                LED_P6=1;\
                LED_P7=1;\
                LED_P8=1;\
                LED_P9=1;\
                LED_P10=1;\
                LED_P11=1;\
                LED_P12=1;\
                LED_P13=1;\
                LED_P14=1;

#define LED_OFF LED_P1=0;\
                LED_P2=0;\
                LED_P3=0;\
                LED_P4=0;\
                LED_P5=0;\
                LED_P6=0;\
                LED_P7=0;\
                LED_P8=0;\
                LED_P9=0;\
                LED_P10=0;\
                LED_P11=0;\
                LED_P12=0;\
                LED_P13=0;\
                LED_P14=0;
          
void User_Init(void);
void User_Main(void);
#endif 
